package com.example.projectapplication;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

public class InputActivity extends AppCompatActivity {

    private String category;
    private String meal;
    private double quantity;
    private String unit;
    private Button btn_inputOK;
    private EditText editText_quantity;
    private TextView textView_unit;
    private TextView textView_manual;

    // 初始化下拉菜单需要用到的的变量
    private List<String> typeList;
    private List<String> mealList;
    private ArrayAdapter<String> listAdapter;
    private Spinner SpinnerT;
    private Spinner SpinnerM;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_input);

        // 给三个变量预设值，以避免空指针
        category = "Bread, Flour & Pasta";
        meal = "Free from White Bread";
        quantity = 0;

        // 找到Spinner控件, 初始化
        SpinnerT = (Spinner)super.findViewById(R.id.spinner_type);
        SpinnerT.setPrompt("Select category:");
        typeList = new ArrayList<String>();
        typeList.add("Bread, Flour & Pasta");
        typeList.add("Cereal & Dairy");
        typeList.add("Fruit & Fruit juice & 7up");
        typeList.add("Snacks");
        typeList.add("\"L\" size meals");
        typeList.add("\"D\" size meals");
        listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,typeList);
        listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        SpinnerT.setAdapter(listAdapter);

        SpinnerM = (Spinner)super.findViewById(R.id.spinner_meal);
        SpinnerM.setPrompt("Select meal:");
        setMealList("Bread, Flour & Pasta");

        // 根据ID找到组件
        editText_quantity = (EditText) findViewById(R.id.editText_quantity);
        btn_inputOK = (Button) findViewById(R.id.btn_inputOK);
        textView_unit = (TextView) findViewById(R.id.textView_unit_text);
        textView_manual = (TextView) findViewById(R.id.textView_manual);

        // 设置按钮监听
        btn_inputOK.setOnClickListener(new InputActivity.MyButton());
        textView_manual.setOnClickListener(new InputActivity.MyButton());

        SpinnerT.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener(){
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                category = typeList.get(position);
                setMealList(category);
             //   System.out.println(meal);
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });

        SpinnerM.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener(){
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                meal = mealList.get(position);
                unit = getUnit(category,meal);
                textView_unit.setText(unit);
                editText_quantity.setHint("Unit: " + unit);
                System.out.println(meal);
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });
    }

    public class MyButton implements View.OnClickListener {
        @Override
        public void onClick(View view) {
            if (view.getId() == R.id.btn_inputOK) {
                    quantity = Double.parseDouble(editText_quantity.getText().toString());
                    //  System.out.println(Double.parseDouble(editText_quantity.getText().toString()));
                    Intent intent = new Intent(InputActivity.this, AddActivity.class);
                    intent.putExtra("meal", meal);//用putExtra把内容传送到另一个Activity,名字是meal，值是meal
                    intent.putExtra("quantity", quantity);//用putExtra把内容传送到另一个Activity,名字是meal，值是meal
                    intent.putExtra("unit", unit);
                    startActivity(intent);//启动第二个activity并把i传递过去
            }
            if (view.getId() == R.id.textView_manual) {
                    Intent intent = new Intent(InputActivity.this, InputActivity_M.class);
                    startActivity(intent);//启动第二个activity并把i传递过去
            }
        }
    }

    public void setMealList(String c){
        if (c.equals("Bread, Flour & Pasta")){
            mealList = new ArrayList<String>();
            mealList.add("Free from White Bread");
            mealList.add("Schar Wholesome white loaf");
            mealList.add("Tesco free from white sliced bread");
            mealList.add("Genius white loaf");
            mealList.add("Schar Gluten Free Pizza Base");
            mealList.add("Doves Farm Gluten Free White Bread Flour");
            mealList.add("Free From Gluten Fusilli pasta");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("Cereal & Dairy")){
            mealList = new ArrayList<String>();
            mealList.add("Gofree cornflakes");
            mealList.add("Gofree Rice pops");
            mealList.add("Free from Honey Hoops");
            mealList.add("GoFree Honeyflakes Dry");
            mealList.add("Lactofree long life semi skimmed milk");
            mealList.add("Lactofree long life whole milk");
            mealList.add("Lactofree Cheddar");
            mealList.add("Lactofree Spreadable butter");
            mealList.add("Lactofree Soft cheese");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("Fruit & Fruit juice & 7up")){
            mealList = new ArrayList<String>();
            mealList.add("Tesco pure apple juice");
            mealList.add("Tesco Orange juice smooth");
            mealList.add("Tesco pineapple juice");
            mealList.add("Tesco Apple and mango juice");
            mealList.add("Tesco apple and raspberry juice");
            mealList.add("Tesco cranberry and raspberry juice");
            mealList.add("Tesco cranberry juice");
            mealList.add("Fruit snack (apple peeled)");
            mealList.add("Fruit snack (pear peeled)");
            mealList.add("7-up");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("Pizza & Sandwiches")){
            mealList = new ArrayList<String>();
            mealList.add("Sandwich with chicken, lettuce, cucumber, tomato");
            mealList.add("Sandwich with egg, lettuce, tomato");
            mealList.add("Sandwich with roast beef, lettuce, tomato");
            mealList.add("Sandwich with cream cheese, cheddar cheese and cucumber");
            mealList.add("Sandwich with chicken, cream cheese");
            mealList.add("Sandwich with egg, cream cheese");
            mealList.add("Sandwich with roast beef, cream cheese");
            mealList.add("Sandwich with cream cheese, cheddar cheese");
            mealList.add("Sandwich with tuna, mayo");
            mealList.add("Pizza with chicken & 1/2 portion tomato dip sauce");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("Snacks")){
            mealList = new ArrayList<String>();
            mealList.add("Chicken and rice soup");
            mealList.add("Chicken and potato soup");
            mealList.add("Rice Pudding");
            mealList.add("Chocolate ice cream");
            mealList.add("Chocolate milk shake");
            mealList.add("Chocolate Rice Pudding");
            mealList.add("Chocolate Custard cream");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("\"L\" size meals")){
            mealList = new ArrayList<String>();
            mealList.add("Chicken with boiled rice and tomato sauce");
            mealList.add("Chicken with mashed potatoes and cheese sauce");
            mealList.add("Chicken pasta bake");
            mealList.add("Chicken with boiled potatoes and tomato sauce");
            mealList.add("Chicken stuffed with cheddar cheese, roasted potatoes and tomato sauce");
            mealList.add("Pork and beef meatballs with spaghetti and tomato sauce");
            mealList.add("Fish Pie (cod, salmon and egg) in a cream sauce topped with mashed potatoes");
            mealList.add("Salmon with mashed potatoes and cheese sauce");
            mealList.add("Cod with boiled rice and tomato sauce");
            mealList.add("Macaroni Cheese");
            mealList.add("Cheese and potato bake");
            mealList.add("Lasagne with beef mince and cheese sauce");
            mealList.add("Tuna Mayo Pasta");
            mealList.add("Fish & Chips");
            mealList.add("Chicken Nuggets & Chips");
            mealList.add("Chicken Burger & Chips");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }

        if (c.equals("\"D\" size meals")){
            mealList = new ArrayList<String>();
            mealList.add("Chicken with boiled rice and tomato sauce");
            mealList.add("Chicken with mashed potatoes and cheese sauce");
            mealList.add("Chicken pasta bake");
            mealList.add("Chicken with boiled potatoes and tomato sauce");
            mealList.add("Chicken stuffed with cheddar cheese, roasted potatoes and tomato sauce");
            mealList.add("Pork and beef meatballs with spaghetti and tomato sauce");
            mealList.add("Fish Pie (cod, salmon and egg) in a cream sauce topped with mashed potatoes");
            mealList.add("Salmon with mashed potatoes and cheese sauce");
            mealList.add("Cod with boiled rice and tomato sauce");
            mealList.add("Macaroni Cheese");
            mealList.add("Cheese and potato bake");
            mealList.add("Lasagne with beef mince and cheese sauce");
            mealList.add("Tuna Mayo Pasta");
            mealList.add("Fish & Chips");
            mealList.add("Chicken Nuggets & Chips");
            mealList.add("Chicken Burger & Chips");
            listAdapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,mealList);
            listAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            SpinnerM.setAdapter(listAdapter);
        }
    }

    private String getUnit(String c, String m) {
        if (c.equals("Bread, Flour & Pasta")){
            if (m.equals("Free from White Bread")){
                return "1 slice 37g";
            } else if (m.equals("Schar Wholesome white loaf")){
                return "1 slice 27g";
            } else if (m.equals("Tesco free from white sliced bread")){
                return "1 slice 33g";
            } else if (m.equals("Genius white loaf")){
                return "1 slice 26g";
            } else if (m.equals("Schar Gluten Free Pizza Base")){
                return "150g = 1 pizza base";
            } else {
                return "100g";
            }
        } else if (c.equals("Cereal & Dairy")) {
            if (m.equals("Lactofree long life semi skimmed milk")){
                return "100ml";
            } else if (m.equals("Lactofree long life whole milk")){
                return "100ml";
            } else {
                return "100g";
            }
        } else if (c.equals("Fruit & Fruit juice & 7up")){
            if (m.equals("Fruit snack (apple peeled)") || m.equals("Fruit snack (pear peeled)")){
                return "One size 100g";
            }  else {
                return "100ml";
            }
        } else if (c.equals("Pizza & Sandwiches") || c.equals("Snacks")){
            return "One size";
        } else if (c.equals("\"L\" size meals")){
            return "Small size";
        } else if (c.equals("\"D\" size meals")){
            return "Large size";
        } else {
            return "100g";
        }
    }
}