package com.example.projectapplication;

import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

import com.android.volley.DefaultRetryPolicy;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.RetryPolicy;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;

public class LoginActivity extends AppCompatActivity {
    private EditText et_userID;
    private EditText et_password;
    private Button btn_login;
    private Button btn_exit;
    private CheckBox checkbox;
    public static String userID;
    public static String group;
    boolean result;

    ProgressDialog loading;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        // Try auto fill login info 尝试自动填充登录信息
        try {
            SharedPreferences sharedPre = getSharedPreferences("UserInfo", MODE_PRIVATE);
            String userID = sharedPre.getString("userID", "");
            String password = sharedPre.getString("password", "");
            et_userID.setText(userID);
            et_password.setText(password);
        }
        catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(LoginActivity.this, "No user info found", Toast.LENGTH_SHORT).show();

        }

      /*  Map<String, String> userInfo = SaveUserLoginInfo.getLoginInfo(this);
            if (userInfo != null) {
            et_userID.setText(userInfo.get("username"));
            et_password.setText(userInfo.get("password"));
        }

       */

        // 根据ID找到对应的组件对象
        et_userID =(EditText) findViewById(R.id.editUserID);
        et_password =(EditText) findViewById(R.id.editPassword);
        checkbox = (CheckBox) findViewById(R.id.checkBox_loginfo);
        btn_login =(Button) findViewById(R.id.btn_login);
        btn_exit =(Button) findViewById(R.id.btn_exit);

        // 设置按钮监听
        btn_login.setOnClickListener(new MyButton());
        btn_exit.setOnClickListener(new MyButton());
    }

    //click events
    public class MyButton implements View.OnClickListener {
        @Override
        public void onClick(View view) {
            userID = et_userID.getText().toString().trim();
            String password = et_password.getText().toString().trim();
            switch (view.getId()) {
                //when clicking the login button 当点击登录按钮时
                case R.id.btn_login:
                    if (TextUtils.isEmpty(userID) || TextUtils.isEmpty(password)) {
                        Toast.makeText(LoginActivity.this, "ID and password needed!", Toast.LENGTH_SHORT).show();
                    } else {
                        if (checkbox.isChecked()) {
                            SharedPreferences mySharedPreferences= getSharedPreferences("UserInfo", Activity.MODE_PRIVATE); //实例化SharedPreferences对象
                            SharedPreferences.Editor editor = mySharedPreferences.edit();//实例化SharedPreferences.Editor对象
                            editor.putString("userID", userID);
                            editor.putString("password",password);//用putString的方法保存数据
                            editor.commit(); //提交当前数据
                        }

                        // 登录的代码，需要包含用户名和密码的验证，错误提示，成功提示
                        login(userID,password);

                    }
                    break;
                //当点击退出按钮事件时
                case R.id.btn_exit:
                    System.exit(0);
                    break;
            }
        }
    }

    private void login(final String userID, final String password) {
        loading = ProgressDialog.show(this, "Loading", "please wait", false, true);

        StringRequest stringRequest = new StringRequest(Request.Method.GET, "https://script.google.com/macros/s/AKfycbz7bkxOjNmfHUu9jQyZLCEZaC9-YK4ak_6OvLPuQ0D3g-ToKaji/exec",
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        System.out.println(response);
                        try {
                            //     String j = jsonResponse.substring(jsonResponse.indexOf("{"), jsonResponse.lastIndexOf("}") + 1);
                            JSONObject jobj = new JSONObject(response);
                            JSONArray jarray = jobj.getJSONArray("items");

                            for (int i = 0; i < jarray.length(); i++) {

                                JSONObject jo = jarray.getJSONObject(i);

                                String id = jo.getString("UserID");
                                String pwd = jo.getString("Password");
                                String group = jo.getString("Group");
                                System.out.println(id);

                                if (id.equals(userID) && pwd.equals(password)) {
                                    result = true;
                                    LoginActivity.group = group;
                                }

                                loading.dismiss();
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                        loading.dismiss();

                        if (result) {
                            Toast.makeText(LoginActivity.this, "Successfully login", Toast.LENGTH_SHORT).show();
                            Intent intent = new Intent(LoginActivity.this, MainActivity.class);
                            startActivity(intent);
                        }
                        else {
                            Toast.makeText(LoginActivity.this, "Incorrect UserID or Password", Toast.LENGTH_SHORT).show();
                        }
                    }
                },

                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                    }
                }
        );

        int socketTimeOut = 50000;
        RetryPolicy policy = new DefaultRetryPolicy(socketTimeOut, 0, DefaultRetryPolicy.DEFAULT_BACKOFF_MULT);

        stringRequest.setRetryPolicy(policy);

        RequestQueue queue = Volley.newRequestQueue(this);
        queue.add(stringRequest);
    }
}