package com.example.projectapplication.ui.records;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ExpandableListView;
import android.widget.ListView;
import android.widget.SimpleAdapter;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import com.android.volley.DefaultRetryPolicy;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.RetryPolicy;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import com.example.projectapplication.AddActivity;
import com.example.projectapplication.R;
import com.google.android.material.floatingactionbutton.FloatingActionButton;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

import utility.ExpandableAdapter;

import static com.example.projectapplication.LoginActivity.userID;

public class RecordFragment extends Fragment {

    // 变量
    private String date;
    private String type ;
    private String meal;
    private Double quantity;

    // ListView 组件
    private ListView recordList;   // ListView 控件
    private ArrayList<HashMap<String, Object>> listItem;  // ListView的数据源，这里是一个HashMap的列表
    private SimpleAdapter listItemAdapter;  // ListView 适配器

    // Expandable ListView 组件
    private ExpandableListView expand_list;
    private ArrayList<String> groups;
    private ArrayList<ArrayList<HashMap<String, Object>>> expandListItem;  // ExpandableListView的数据源，这里是一个HashMap的列表

    // 组件
    private FloatingActionButton btn_AddRecord;
    //private FloatingActionButton btn_Refresh;
    ProgressDialog loading;

    // onCreateView 方法
    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_record_page, null);

        btn_AddRecord = (FloatingActionButton) view.findViewById(R.id.btn_AddRecord);
        //btn_Refresh = (FloatingActionButton) view.findViewById(R.id.btn_Refresh);

        // 初始化 ListView 变量
        listItem = new ArrayList<HashMap<String, Object>>();
        listItemAdapter = new SimpleAdapter(
                this.getContext(),
                listItem,
                R.layout.fragment_record_entry,
                new String[]{"date","type","meal", "quantity"},
                new int[]{R.id.textView_date, R.id.textView_type, R.id.textView_meal, R.id.textView_quantity}
        );
        recordList = (ListView) view.findViewById(R.id.listview_record);
        recordList.setAdapter(listItemAdapter);

        //初始化 expandable ListView 变量
        groups = new ArrayList<String>();
        expandListItem = new ArrayList<ArrayList<HashMap<String, Object>>>();

        expand_list= view.findViewById(R.id.expand_list);
        ExpandableAdapter adapter=new ExpandableAdapter(this.getContext(),groups,expandListItem);
        expand_list.setAdapter(adapter);
        //默认展开第一个数组
        expand_list.expandGroup(0);
        //关闭数组某个数组，可以通过该属性来实现全部展开和只展开一个列表功能
        //expand_list_id.collapseGroup(0);
        expand_list.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {
            @Override
            public boolean onGroupClick(ExpandableListView expandableListView, View view, int groupPosition, long l) {
                // showToastShort(groups[groupPosition]);
                return false;
            }
        });
        //子视图的点击事件
        expand_list.setOnChildClickListener(new ExpandableListView.OnChildClickListener() {
            @Override
            public boolean onChildClick(ExpandableListView expandableListView, View view, int groupPosition, int childPosition, long l) {
              //  showToastShort(childs[groupPosition][childPosition]);
                return true;
            }
        });



        // 设置按钮监听
        btn_AddRecord.setOnClickListener(new MyButton());
        //btn_Refresh.setOnClickListener(new MyButton());

        // 显示数据
        getItems();

        return view;
    }

    private void initView(){


    }


    public class MyButton implements View.OnClickListener {
        @Override
        public void onClick(View view) {
            if (view.getId() == R.id.btn_AddRecord) {
                        // Toast 方法显示弹窗
                        // Toast.makeText(getActivity(), "Add new record", Toast.LENGTH_SHORT).show();
                        Intent intent = new Intent(getActivity().getApplicationContext(), AddActivity.class);
                        startActivity(intent);
            }
            /*if (view.getId() == R.id. btn_Refresh) {
                        getItems();
            }

             */
        }
    }

    private void getItems() {

        loading = ProgressDialog.show(this.getContext(), "Loading", "please wait", false, true);
        StringRequest stringRequest = new StringRequest(Request.Method.GET, "https://script.google.com/macros/s/AKfycby1ry5uPrQq_Ci3-XkDJPXA5XKZd5qikrB56xv2OLTamcWxwytt/exec",
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        System.out.println(response);
                        parseItems(response);
                    }
                },

                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                    }
                }
        );

        int socketTimeOut = 50000;
        RetryPolicy policy = new DefaultRetryPolicy(socketTimeOut, 0, DefaultRetryPolicy.DEFAULT_BACKOFF_MULT);

        stringRequest.setRetryPolicy(policy);

        RequestQueue queue = Volley.newRequestQueue(this.getContext());
        queue.add(stringRequest);
    }


    private void parseItems(String jsonResponse) {

        try {
       //     String j = jsonResponse.substring(jsonResponse.indexOf("{"), jsonResponse.lastIndexOf("}") + 1);
            JSONObject jobj = new JSONObject(jsonResponse);
            JSONArray jarray = jobj.getJSONArray("items");

            for (int i = 0; i < jarray.length(); i++) {

                JSONObject jo = jarray.getJSONObject(i);

                String id =  jo.getString("UserID");
                date = jo.getString("Date").substring(0, 10);
                type = jo.getString("MealType");
                meal = jo.getString("Meal");
                quantity = jo.getDouble("Quantity");
                System.out.println(meal);

             /*   String newDate="";
                if (!newDate.equals(date)) {
                    System.out.println(date);
                    groups.add(date);
                    newDate = date;
                }
              */

             if (id.equals(userID)) {
                 HashMap<String, Object> item = new HashMap<>();
                 item.put("date", date);
                 item.put("type", type);
                 item.put("meal", meal);
                 item.put("quantity", quantity);


                 listItem.add(item);
                 expandListItem.add(listItem);
             }

            }
        } catch (JSONException e) {
            e.printStackTrace();
        }

        listItemAdapter.notifyDataSetChanged();
        loading.dismiss();
    }
}

