package utility;

import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.sql.Date;
import java.util.Iterator;

import javax.net.ssl.HttpsURLConnection;

public class SSpost extends AppCompatActivity {

    String userID;
    Date date;
    String type;
    String meal;
    Double quantity;
    String unit;

    public void sendRecord(String userID, Date date, String type, String meal, Double quantity, String unit){
        this.userID = userID;
        this.date = date;
        this.type = type;
        this.meal = meal;
        this.quantity = quantity;
        this.unit = unit;
        new SendRequest().execute();
    }

    public class SendRequest extends AsyncTask<String, Void, String> {

        protected void onPreExecute(){}

        protected String doInBackground(String... arg0) {
            try{
                URL url = new URL("https://script.google.com/macros/s/AKfycbzmDCGxQzatHnyXaWvjcLRRWTK2y76ejrTGDIaSsK3rXJsVoeA/exec");
                // Google APP Script URL
                JSONObject postDataParams = new JSONObject();

                //    String usn = Integer.toString(i);
                String id= "1ZICBbBNBLraWkj0OncFwBXZLLfjRfonazYjKk1I0x9g";

                postDataParams.put("id",id);
                postDataParams.put("UserID",userID);
                postDataParams.put("Date",date);
                postDataParams.put("MealType",type);
                postDataParams.put("Meal",meal);
                postDataParams.put("Quantity",quantity);
                postDataParams.put("Unit",unit);


                Log.e("params",postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(15000 /* milliseconds */);
                conn.setConnectTimeout(15000 /* milliseconds */);
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(
                        new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode=conn.getResponseCode();

                if (responseCode == HttpsURLConnection.HTTP_OK) {

                    BufferedReader in=new BufferedReader(new InputStreamReader(conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line="";

                    while((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                }
                else {
                    return new String("false : "+responseCode);
                }
            }
            catch(Exception e){
                return new String("Exception: " + e.getMessage());
            }
        }

        @Override
        protected void onPostExecute(String result) {
     //       Toast.makeText(getApplicationContext(), result,
     //               Toast.LENGTH_LONG).show();
        }
    }

    public String getPostDataString(JSONObject params) throws Exception {

        StringBuilder result = new StringBuilder();
        boolean first = true;

        Iterator<String> itr = params.keys();

        while(itr.hasNext()){

            String key= itr.next();
            Object value = params.get(key);

            if (first)
                first = false;
            else
                result.append("&");

            result.append(URLEncoder.encode(key, "UTF-8"));
            result.append("=");
            result.append(URLEncoder.encode(value.toString(), "UTF-8"));

        }
        return result.toString();
    }
}
